#include "QViewport.h"
#include <gl/GLU.h>
#include <gl/GL.h>

QViewport::QViewport(QWidget* parent) : QOpenGLWidget(parent) {
	this->vertices[0] = Vertex(-1.0f, -1.0f, 0.0f);
	this->vertices[1] = Vertex(0.0f, 1.0f, 0.0f);
	this->vertices[2] = Vertex(1.0f, -1.0f, 0.0f);

	this->vertices[0].r = 1.0f;
	this->vertices[1].g = 1.0f;
	this->vertices[2].b = 1.0f;
}

QViewport::~QViewport() {

}

void QViewport::initializeGL() {
	glClearColor(0.0f, 0.0f, 0.0f, 1.0f);
}

void QViewport::paintGL() {
	glClear(GL_COLOR_BUFFER_BIT);

	glPushMatrix();
		gluLookAt(0.0f, 0.0f, 2.0f, 0.0f, 0.0f, 0.0f, 0.0f, 1.0f, 0.0f);

		glBegin(GL_TRIANGLES);
			glColor3f(this->vertices[0].r, this->vertices[0].g, this->vertices[0].b);
			glVertex3f(this->vertices[0].x, this->vertices[0].y, this->vertices[0].z);
			glColor3f(this->vertices[1].r, this->vertices[1].g, this->vertices[1].b);
			glVertex3f(this->vertices[1].x, this->vertices[1].y, this->vertices[1].z);
			glColor3f(this->vertices[2].r, this->vertices[2].g, this->vertices[2].b);
			glVertex3f(this->vertices[2].x, this->vertices[2].y, this->vertices[2].z);
		glEnd();

	glPopMatrix();
}

void QViewport::resizeGL(int w, int h) {
	glViewport(0, 0, w, h);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(65.0, GLfloat(w)/GLfloat(h), 0.01, 1000.0);
	glMatrixMode(GL_MODELVIEW);
}
